应用程序名称: SpanDirection

Revit 平台: 结构

Revit 版本: 2011.0

首次发布版本: 8.1

编程语言: C#

技能级别: 初级

类别: 参数、元素

类型: 外部命令

主题: 结构楼板(板)的日期检索。

概要: 此示例演示如何获取结构楼板(板)的跨度方向和跨度方向符号。

相关类:

Autodesk.Revit.UI.IExternalCommand

Autodesk.Revit.DB.ElementSet

Autodesk.Revit.DB.Floor

Autodesk.Revit.DB.ElementArray

Autodesk.Revit.DB.ElementArrayIterator

项目文件:

Command.cs

该文件包含从 IExternalCommand 接口继承的 Command 类,并实现了 Execute 方法,该类实现了获取楼板相关信息的所有功能。

描述:

此示例主要使用楼板类来实现获取楼板(板)属性的功能:跨度方向角和跨度方向符号。

- 通过 ActiveDocument.Selection.Elements 可以获取楼板对象。

- 使用 Floor.SpanDirectionAngle Floor.SpanDirectionSymbols 属性可以检索楼板(板)的跨度方向角和跨度方向符号。

- 要获取跨度方向符号,可以使用 Element.ObjectType.Name

说明:

1. 启动 Revit 结构,绘制一个楼板板,在 Revit 中选择它。

2. 单击外部命令,将弹出一个消息框,在此之后将显示该楼板板的跨度方向角和跨度方向符号。

3. 如果您无法创建具有跨度方向的楼板,请使用“Structural Analysis-Default.rte”文件作为 Revit Structure 的默认模板文件。

4. 示例项目文件夹下有一个名为 SpanDirection.rvt .rvt 文件,跨度方向和跨度方向符号已经被添加,您可以打开此文件并选择现有的楼板进行运行示例

源代码:
完整的源代码请加入QQ群649037449,在群文件中下载RevitSDK.exe,解压后在文件夹中搜索本文中应用程序名称即可获得完整源码

Command.cs

//
// (C) Copyright 2003-2019 by Autodesk, Inc.
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted,
// provided that the above copyright notice appears in all copies and
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE. AUTODESK, INC.
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//
using System;
using System.Windows.Forms;
using Autodesk.Revit;
using Autodesk.Revit.DB.Structure;
using Autodesk.Revit.DB;
using Autodesk.Revit.UI;
namespace Revit.SDK.Samples.SpanDirection.CS
{
    /// <summary>
    /// Get Span direction of Floor and all the SpanDirection Symbols
    /// </summary>
    [Autodesk.Revit.Attributes.Transaction(Autodesk.Revit.Attributes.TransactionMode.Manual)]
    [Autodesk.Revit.Attributes.Regeneration(Autodesk.Revit.Attributes.RegenerationOption.Manual)]
    [Autodesk.Revit.Attributes.Journaling(Autodesk.Revit.Attributes.JournalingMode.NoCommandData)]
    public class Command : IExternalCommand
    {
        public Document m_docment;
        #region Interface implementation
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application 
        /// which contains data related to the command, 
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application 
        /// which will be displayed if a failure or cancellation is returned by 
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application 
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command. 
        /// A result of Succeeded means that the API external method functioned as expected. 
        /// Cancelled can be used to signify that the user cancelled the external operation 
        /// at some point. Failure should be returned if the application is unable to proceed with 
        /// the operation.</returns>
        public Autodesk.Revit.UI.Result Execute(Autodesk.Revit.UI.ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements)
        {
            Autodesk.Revit.UI.UIApplication application = commandData.Application;
            m_docment = application.ActiveUIDocument.Document;
            try
            {
                // user should select one slab firstly. 
                if (application.ActiveUIDocument.Selection.GetElementIds().Count == 0)
                {
                    TaskDialog.Show("Revit", "Please select one slab firstly.", TaskDialogCommonButtons.Ok);
                    return Autodesk.Revit.UI.Result.Cancelled;
                }
                // get the selected slab and show its span direction
                ElementSet elementSet = new ElementSet();
                foreach (ElementId elementId in application.ActiveUIDocument.Selection.GetElementIds())
                {
                   elementSet.Insert(application.ActiveUIDocument.Document.GetElement(elementId));
                }
                ElementSetIterator elemIter = elementSet.ForwardIterator();
                elemIter.Reset();
                while (elemIter.MoveNext())
                {
                    Floor floor = elemIter.Current as Floor;
                    if (floor != null)
                    {
                        GetSpanDirectionAndSymobls(floor);
                    }
                }
            }
            catch (Exception ex)
            {
                message = ex.ToString();
                return Autodesk.Revit.UI.Result.Failed;
            }
            return Autodesk.Revit.UI.Result.Succeeded;
        }
        #endregion
        /// <summary>
        /// Get SpanDirection and SpanDirectionSymobols of Floor
        /// </summary>
        /// <param name="floor"></param>
        void GetSpanDirectionAndSymobls(Floor floor)
        {
            if (null != floor)
            {
                // get SpanDirection angle of Floor(Slab)
                // The angle returned is in radians. An exception will be thrown if the floor
                // is non structural.
                String spanDirAngle = "Span direction angle: " + floor.SpanDirectionAngle.ToString() + "\r\n";
                // get span direction symbols of Floor(Slab)
                String symbols = "Span direction symbols: \r\n\t";
                System.Collections.Generic.ICollection<ElementId> symbolArray = floor.GetSpanDirectionSymbolIds();
                //ElementArrayIterator symbolIter = symbolArray.ForwardIterator();
                //symbolIter.Reset();
                //while (symbolIter.MoveNext())
                foreach (ElementId eid in symbolArray)
                {
                    Element elem = m_docment.GetElement(eid);
                    if (elem != null)
                    {
                        symbols += (m_docment.GetElement(elem.GetTypeId()) as ElementType).Name + "\r\n";
                    }
                }
                TaskDialog.Show("Revit Direction", spanDirAngle + symbols, TaskDialogCommonButtons.Ok);
            }
            else
            {
                new Exception("Get Floor and SpanDirectionAngle and Symbols failed!");
            }
        }
    }
}